import mailstoreapi
from time import sleep

"""
in some cases after an upgrade of mailstore some folders might be created under a new name
the Inbox e.g. might be renamed to INBOX
in that cases old mails are in Inbox, new one are in INBOX

it is not a good idea to rename INBOX to Inbox, because mailstore will recreate the
INBOX folder every time it finds new mails in it in the source (mailbox)

so the preferred way is, to rename Inbox to INBOX

this script scans for ALL folder that end with "Inbox" and renames them to "[..]INBOX"
"""


#enter your server credentials here
HOST = "localhost"
USER = "admin"
PASS = "admin"
PORT = 8463


#only apply changes under this line if you are familiar with python and mailstore api
def replace_inbox(foldername):
    global api
    if foldername.endswith("Inbox"):
        targetfolder = foldername.replace("Inbox","INBOX")
        print("+---------------------------------")
        print("|renaming folder {} -> {}".format(foldername,targetfolder))
        token = api.MoveFolder(foldername,targetfolder, False)
        status = api.GetToken(token)
        while status["progressPercentage"] < 100:      
            print("|percent done:",status["progressPercentage"])
            sleep(1)
            status = api.GetToken(token)
        else:
            print("|percent done:",status["progressPercentage"])
            print("|"+status["status"])
            for v in status["messages"]:
                print("|"+v["text"])             
        print("+---------------------------------")          
    else:
        print(foldername)
    

def process_folders(folders,external_function=print,deepness=0, showpath=1, path=""):
    for folder in folders:
        FolderPrintName = folder["name"] if not showpath else path+folder["name"]
        output =" "*deepness*4+FolderPrintName
        external_function(output)
        if folder["hasChildFolders"]:
           process_folders(folder["childFolders"], external_function, deepness+1 if not showpath else deepness,showpath,path=FolderPrintName+"/")

 
api = mailstoreapi.ManagementAPI(USER,PASS,HOST,PORT)

folders = api.GetChildFolders()["childFolders"]
process_folders(folders,replace_inbox)
print(("*"*25+"\n")*2)
folders = api.GetChildFolders()["childFolders"]
process_folders(folders)


